-- C:\WORK\HDL\SAMPLE\ASB004_07\EPNCTL_WAVE.VHW
-- VHDL Test Bench created by
-- HDL Bencher 4.1i
-- Fri Oct 18 19:17:22 2002
-- 
-- Notes:
-- 1) This testbench has been automatically generated from
--   your Test Bench Waveform
-- 2) To use this as a user modifiable testbench do the following:
--   - Save it as a file with a .vhd extension (i.e. File->Save As...)
--   - Add it to your project as a testbench source (i.e. Project->Add Source...)
-- 

LIBRARY  IEEE;
USE IEEE.STD_LOGIC_1164.ALL;
USE IEEE.STD_LOGIC_ARITH.ALL;
USE IEEE.STD_LOGIC_UNSIGNED.ALL;

LIBRARY ieee;
USE IEEE.STD_LOGIC_TEXTIO.ALL;
USE STD.TEXTIO.ALL;

ENTITY testbench IS
END testbench;

ARCHITECTURE testbench_arch OF testbench IS
-- If you get a compiler error on the following line,
-- from the menu do Options->Configuration select VHDL 87
FILE RESULTS: TEXT OPEN WRITE_MODE IS "results.txt";
	COMPONENT EPNCTL
		PORT (
			CLK : in  std_logic;
			RST : in  std_logic;
			DATA_IN : in  std_logic_vector (31 DOWNTO 0);
			RE : in  std_logic;
			RE_BSY : out  std_logic;
			DATA_OUT : out  std_logic_vector (31 DOWNTO 0);
			WE : out  std_logic;
			WE_RDY : in  std_logic;
			L : out  std_logic_vector (1 DOWNTO 0);
			HRST : out  std_logic;
			HD : inout  std_logic_vector (15 DOWNTO 0);
			HA : out  std_logic_vector (2 DOWNTO 0);
			HCS : out  std_logic;
			HWR : out  std_logic_vector (1 DOWNTO 0);
			HRD : out  std_logic_vector (1 DOWNTO 0)
		);
	END COMPONENT;

	SIGNAL CLK : std_logic;
	SIGNAL RST : std_logic;
	SIGNAL DATA_IN : std_logic_vector (31 DOWNTO 0);
	SIGNAL RE : std_logic;
	SIGNAL RE_BSY : std_logic;
	SIGNAL DATA_OUT : std_logic_vector (31 DOWNTO 0);
	SIGNAL WE : std_logic;
	SIGNAL WE_RDY : std_logic;
	SIGNAL L : std_logic_vector (1 DOWNTO 0);
	SIGNAL HRST : std_logic;
	SIGNAL HD : std_logic_vector (15 DOWNTO 0);
	SIGNAL HA : std_logic_vector (2 DOWNTO 0);
	SIGNAL HCS : std_logic;
	SIGNAL HWR : std_logic_vector (1 DOWNTO 0);
	SIGNAL HRD : std_logic_vector (1 DOWNTO 0);

BEGIN
	UUT : EPNCTL
	PORT MAP (
		CLK => CLK,
		RST => RST,
		DATA_IN => DATA_IN,
		RE => RE,
		RE_BSY => RE_BSY,
		DATA_OUT => DATA_OUT,
		WE => WE,
		WE_RDY => WE_RDY,
		L => L,
		HRST => HRST,
		HD => HD,
		HA => HA,
		HCS => HCS,
		HWR => HWR,
		HRD => HRD
	);

	PROCESS -- clock process
	BEGIN
		CLOCK_LOOP : LOOP
		CLK <= transport '0';
		WAIT FOR 10 ns;
		CLK <= transport '1';
		WAIT FOR 10 ns;
		WAIT FOR 17 ns;
		CLK <= transport '0';
		WAIT FOR 17 ns;
		END LOOP CLOCK_LOOP;
	END PROCESS;

	PROCESS
		VARIABLE TX_OUT : LINE;
		VARIABLE TX_ERROR : INTEGER := 0;

		PROCEDURE CHECK_RE_BSY(
			next_RE_BSY : std_logic;
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 4096);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (RE_BSY /= next_RE_BSY) THEN 
				write(TX_LOC,string'("Error at time="));
				write(TX_LOC, TX_TIME);
				write(TX_LOC,string'("ns RE_BSY="));
				write(TX_LOC, RE_BSY);
				write(TX_LOC, string'(", Expected = "));
				write(TX_LOC, next_RE_BSY);
				write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				writeline(results, TX_LOC);
				Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		PROCEDURE CHECK_DATA_OUT(
			next_DATA_OUT : std_logic_vector (31 DOWNTO 0);
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 4096);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (DATA_OUT /= next_DATA_OUT) THEN 
				write(TX_LOC,string'("Error at time="));
				write(TX_LOC, TX_TIME);
				write(TX_LOC,string'("ns DATA_OUT="));
				write(TX_LOC, DATA_OUT);
				write(TX_LOC, string'(", Expected = "));
				write(TX_LOC, next_DATA_OUT);
				write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				writeline(results, TX_LOC);
				Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		PROCEDURE CHECK_WE(
			next_WE : std_logic;
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 4096);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (WE /= next_WE) THEN 
				write(TX_LOC,string'("Error at time="));
				write(TX_LOC, TX_TIME);
				write(TX_LOC,string'("ns WE="));
				write(TX_LOC, WE);
				write(TX_LOC, string'(", Expected = "));
				write(TX_LOC, next_WE);
				write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				writeline(results, TX_LOC);
				Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		PROCEDURE CHECK_HRST(
			next_HRST : std_logic;
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 4096);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (HRST /= next_HRST) THEN 
				write(TX_LOC,string'("Error at time="));
				write(TX_LOC, TX_TIME);
				write(TX_LOC,string'("ns HRST="));
				write(TX_LOC, HRST);
				write(TX_LOC, string'(", Expected = "));
				write(TX_LOC, next_HRST);
				write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				writeline(results, TX_LOC);
				Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		PROCEDURE CHECK_HA(
			next_HA : std_logic_vector (2 DOWNTO 0);
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 4096);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (HA /= next_HA) THEN 
				write(TX_LOC,string'("Error at time="));
				write(TX_LOC, TX_TIME);
				write(TX_LOC,string'("ns HA="));
				write(TX_LOC, HA);
				write(TX_LOC, string'(", Expected = "));
				write(TX_LOC, next_HA);
				write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				writeline(results, TX_LOC);
				Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		PROCEDURE CHECK_HCS(
			next_HCS : std_logic;
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 4096);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (HCS /= next_HCS) THEN 
				write(TX_LOC,string'("Error at time="));
				write(TX_LOC, TX_TIME);
				write(TX_LOC,string'("ns HCS="));
				write(TX_LOC, HCS);
				write(TX_LOC, string'(", Expected = "));
				write(TX_LOC, next_HCS);
				write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				writeline(results, TX_LOC);
				Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		PROCEDURE CHECK_HWR(
			next_HWR : std_logic_vector (1 DOWNTO 0);
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 4096);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (HWR /= next_HWR) THEN 
				write(TX_LOC,string'("Error at time="));
				write(TX_LOC, TX_TIME);
				write(TX_LOC,string'("ns HWR="));
				write(TX_LOC, HWR);
				write(TX_LOC, string'(", Expected = "));
				write(TX_LOC, next_HWR);
				write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				writeline(results, TX_LOC);
				Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		PROCEDURE CHECK_HRD(
			next_HRD : std_logic_vector (1 DOWNTO 0);
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 4096);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (HRD /= next_HRD) THEN 
				write(TX_LOC,string'("Error at time="));
				write(TX_LOC, TX_TIME);
				write(TX_LOC,string'("ns HRD="));
				write(TX_LOC, HRD);
				write(TX_LOC, string'(", Expected = "));
				write(TX_LOC, next_HRD);
				write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				writeline(results, TX_LOC);
				Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		PROCEDURE CHECK_HD(
			next_HD : std_logic_vector (15 DOWNTO 0);
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 4096);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (HD /= next_HD) THEN 
				write(TX_LOC,string'("Error at time="));
				write(TX_LOC, TX_TIME);
				write(TX_LOC,string'("ns HD="));
				write(TX_LOC, HD);
				write(TX_LOC, string'(", Expected = "));
				write(TX_LOC, next_HD);
				write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				writeline(results, TX_LOC);
				Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		PROCEDURE CHECK_L(
			next_L : std_logic_vector (1 DOWNTO 0);
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 4096);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (L /= next_L) THEN 
				write(TX_LOC,string'("Error at time="));
				write(TX_LOC, TX_TIME);
				write(TX_LOC,string'("ns L="));
				write(TX_LOC, L);
				write(TX_LOC, string'(", Expected = "));
				write(TX_LOC, next_L);
				write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				writeline(results, TX_LOC);
				Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		BEGIN
		-- --------------------
		RST <= transport '1';
		DATA_IN <= transport std_logic_vector'("00000000000000000000000000000000"); --0
		RE <= transport '0';
		WE_RDY <= transport '1';
		-- --------------------
		WAIT FOR 54 ns; -- Time=54 ns
		RST <= transport '0';
		-- --------------------
		WAIT FOR 54 ns; -- Time=108 ns
		DATA_IN <= transport std_logic_vector'("00010110101000100001001000110100"); --16A21234
		-- --------------------
		WAIT FOR 54 ns; -- Time=162 ns
		RE <= transport '1';
		-- --------------------
		WAIT FOR 54 ns; -- Time=216 ns
		RE <= transport '0';
		-- --------------------
		WAIT FOR 432 ns; -- Time=648 ns
		DATA_IN <= transport std_logic_vector'("00010110010101000001001000110100"); --16541234
		-- --------------------
		WAIT FOR 54 ns; -- Time=702 ns
		RE <= transport '1';
		-- --------------------
		WAIT FOR 54 ns; -- Time=756 ns
		RE <= transport '0';
		-- --------------------
		WAIT FOR 378 ns; -- Time=1134 ns
		DATA_IN <= transport std_logic_vector'("00010110000110100000000000000000"); --161A0000
		-- --------------------
		WAIT FOR 108 ns; -- Time=1242 ns
		RE <= transport '1';
		-- --------------------
		WAIT FOR 54 ns; -- Time=1296 ns
		RE <= transport '0';
		-- --------------------
		WAIT FOR 4303 ns; -- Time=5599 ns
		-- --------------------

		IF (TX_ERROR = 0) THEN 
			write(TX_OUT,string'("No errors or warnings"));
			writeline(results, TX_OUT);
			ASSERT (FALSE) REPORT
				"Simulation successful (not a failure).  No problems detected. "
				SEVERITY FAILURE;
		ELSE
			write(TX_OUT, TX_ERROR);
			write(TX_OUT, string'(
				" errors found in simulation"));
			writeline(results, TX_OUT);
			ASSERT (FALSE) REPORT
				"Errors found during simulation"
				SEVERITY FAILURE;
		END IF;
	END PROCESS;
END testbench_arch;

CONFIGURATION EPNCTL_cfg OF testbench IS
	FOR testbench_arch
	END FOR;
END EPNCTL_cfg;
